//-----------------------------------------------------------------------------
//Test_Ufw_Csm_Proc.java
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
//Package Definition
//-----------------------------------------------------------------------------
package uicc.usim.test.usatframework.ufw_csm_proc;

//-----------------------------------------------------------------------------
//Import
//-----------------------------------------------------------------------------
import org._3gpp.ct.wg6.usim.jcapi.userclass.*;
import org.etsi.scp.wg3.uicc.jcapi.userclass.*;
import org.etsi.scp.wg3.uicc.jcapi.userinterface.*;

public class Test_Ufw_Csm_Proc extends UiccTestModel {

    static final String CAP_FILE_PATH = "uicc/usim/test/usatframework/ufw_csm_proc";

    private final String CLASS_AID_1  = "A0000000 871005FF FFFFFF89 50010001";

    private final String APPLET_AID_1 = "A0000000 871005FF FFFFFF89 50010102";

    /** formatted SMS 1 of 3 */
    private final String        FORMATTED_SMS_11= "06060000 00000000 0B33400B D0214365" +
                                                  "8709F17F 16FFFFFF FFFFFFFF 20070003" +
                                                  "00030170 0000260D 00000000 50010100" +
                                                  "00000000 00010101 01010101 01";

    /** formatted SMS 2 of 3 */
    private final String        FORMATTED_SMS_12= "06060000 00000000 0B21400B D0214365" +
                                                  "8709F17F 16FFFFFF FFFFFFFF 0E050003" +
                                                  "00030202 02020202 020202";

    /** formatted SMS 3 of 3 */
    private final String        FORMATTED_SMS_13= "06060000 00000000 0B21400B D0214365" +
                                                  "8709F17F 16FFFFFF FFFFFFFF 0E050003" +
                                                  "00030303 03030303 030303";

    /** formatted SMS 1 of 3 */
    private final String        FORMATTED_SMS_21= "06060000 00430000 0B33400B D0214365" +
                                                  "8709F17F 16FFFFFF FFFFFFFF 20070003" +
                                                  "00030170 0000260D 00000000 50010100" +
                                                  "00000000 00010101 01010101 01";
    /** formatted SMS 2 of 3 */
    private final String        FORMATTED_SMS_22= "06060000 00430000 0B21400B D0214365" +
                                                  "8709F17F 16FFFFFF FFFFFFFF 0E050003" +
                                                  "00030202 02020202 020202";
    /** formatted SMS 1 of 3 */
    private final String        FORMATTED_SMS_31= "06060000 00000000 0B33400B D0214365" +
                                                  "8709F17F 1AAAAAFF FFFFFFFF 20070003" +
                                                  "00030170 0000260D 00000000 50010100" +
                                                  "00000000 00010101 01010101 01";
    /** formatted SMS 2 of 3 */
    private final String        FORMATTED_SMS_32= "06060000 00000000 0B21400B D0214365" +
                                                  "8709F17F F6FFBBBB FFFFFFFF 0E050003" +
                                                  "00030202 02020202 020202";

/** formatted SMS 1 of 3 */
    private final String        FORMATTED_SMS_41= "06060000 00000000 0B33400B D0214365" +
                                                  "8709F17F F6FFFFFF FFFFFFFF 20070003" +
                                                  "00030170 0000260D 00000000 50010100" +
                                                  "00000000 00010101 01010101 01";
    /** formatted SMS 2 of 3 */
    private final String        FORMATTED_SMS_42= "06060000 00000000 0B21400B D0214365" +
                                                  "8709F17F F6FFFFFF FFFFFFFF 0E050003" +
                                                  "00030202 02020202 020202";

    /** formatted SMS 3 of 3 */
    private final String        FORMATTED_SMS_43= "06060000 00000000 0B21400B D0214365" +
                                                  "8709F17F F6FFFFFF FFFFFFFF 0E050003" +
                                                  "00030303 03030303 030303";

    /** unformatted SMS 1 of 3 */
    private final String      UNFORMATTED_SMS_51= "06060000 00000000 0B31400B D0214365" +
                                                  "8709F17F F6FFFFFF FFFFFFFF 1E050003" +
                                                  "00030100 260D0000 00002001 01000000" +
                                                  "00000001 01010101 010101";
    /** unformatted SMS 2 of 3 */
    private final String      UNFORMATTED_SMS_52= "06060000 00000000 0B21400B D0214365" +
                                                  "8709F17F 1AFFFFFF FFFFFFFF 0E050003" +
                                                  "00030202 02020202 020202";

    /** formatted SMS 3 of 3 */
    private final String      UNFORMATTED_SMS_53= "06060000 00000000 0B21400B D0214365" +
                                                  "8709F17F 1AFFFFFF FFFFFFFF 0E050003" +
                                                  "00030303 03030303 030303";

    /** unformatted SMS 1 of 3 */
    private final String      UNFORMATTED_SMS_61= "06060000 00430000 0B31400B D0214365" +
                                                  "8709F17F F6FFFFFF FFFFFFFF 1E050003" +
                                                  "00030100 260D0000 00002001 01000000" +
                                                  "00000001 01010101 010101";
    /** unformatted SMS 2 of 3 */
    private final String      UNFORMATTED_SMS_62= "06060000 00430000 0B21400B D0214365" +
                                                  "8709F17F F6FFFFFF FFFFFFFF 0E050003" +
                                                  "00030202 02020202 020202";

    /** unformatted SMS 1 of 3 */
    private final String      UNFORMATTED_SMS_71= "06060000 00000000 0B31400B D0214365" +
                                                  "8709F17F F6FFFFFF FFFFFFFF 1E050003" +
                                                  "00030100 260D0000 00002001 01000000" +
                                                  "00000001 01010101 010101";
    /** unformatted SMS 2 of 3 */
    private final String      UNFORMATTED_SMS_72= "06060000 00000000 0B21400B D0214365" +
                                                  "8709F17F 1AFFDFFF F1FFFFFF 0E050003" +
                                                  "00030202 02020202 020202";

    /** unformatted SMS 1 of 3 */
    private final String      UNFORMATTED_SMS_81= "06060000 00000000 0B31400B D0214365" +
                                                  "8709F17F F6FFFFFF FFFFFFFF 1E050003" +
                                                  "00030100 260D0000 00002001 01000000" +
                                                  "00000001 01010101 010101";
    /** unformatted SMS 2 of 3 */
    private final String      UNFORMATTED_SMS_82= "06060000 00000000 0B21400B D0214365" +
                                                  "8709F17F F6FFFFFF FFFFFFFF 0E050003" +
                                                  "00030202 02020202 020202";

    /** formatted SMS 3 of 3 */
    private final String      UNFORMATTED_SMS_83= "06060000 00000000 0B21400B D0214365" +
                                                  "8709F17F F6FFFFFF FFFFFFFF 0E050003" +
                                                  "00030303 03030303 030303";




    /** */
    private USimAPITestCardService test;
    /** contains the response of the processed apdu*/
    private APDUResponse response;
    /** */
    public Test_Ufw_Csm_Proc() {
        test = USimAPITestCardService.getTheUSimTestCardService();
    }
    /**
     * @todo terminal profile
     */
    public boolean run() {
            initialiseResults();

            // test script
            test.reset();
            test.terminalProfileSession("1719");
            // Install package
            test.loadPackage(CAP_FILE_PATH);
            // Install Applet1
            test.installApplet(CAP_FILE_PATH, CLASS_AID_1, APPLET_AID_1,
                              "8008" + // TLV UICC Toolkit application specific parameters
                              "01" +   // V Priority Level
                              "00" +   // V Max. number of timers
                              "00" +   // V Maximum text length for a menu entry
                              "00" +   // V Maximum number of menu entries
                              "00" +   // V Maximum number of channels
                              "00" +   // LV Minimum Security Level field
                              "00" +   // LV TAR Value(s)
                              "00" );  // V Maximum number of services

            //send terminal profile and response
            test.reset();
            test.terminalProfileSession("03010000 0102");

            //TC 1 - send formatted sms and check content
            response = test.envelopeSmsPp(FORMATTED_SMS_12);
            response = test.envelopeSmsPp(FORMATTED_SMS_11);
            response = test.envelopeSmsPp(FORMATTED_SMS_13);
            //TC 2 - address fields of formatted sms parts are different
            response = test.envelopeSmsPp(FORMATTED_SMS_22);
            response = test.envelopeSmsPp(FORMATTED_SMS_21);
            response = test.envelopeSmsPp(FORMATTED_SMS_13);
            //TC 3 - some tp fields of formatted sms parts are different
            response = test.envelopeSmsPp(FORMATTED_SMS_32);
            response = test.envelopeSmsPp(FORMATTED_SMS_31);
            response = test.envelopeSmsPp(FORMATTED_SMS_13);
            //TC 4 - send formatted sms with dcs 8bit
            response = test.envelopeSmsPp(FORMATTED_SMS_41);
            response = test.envelopeSmsPp(FORMATTED_SMS_42);
            response = test.envelopeSmsPp(FORMATTED_SMS_43);

            //TC 5 - send unformatted sms
            response = test.envelopeSmsPp(UNFORMATTED_SMS_52);
            response = test.envelopeSmsPp(UNFORMATTED_SMS_51);
            response = test.envelopeSmsPp(UNFORMATTED_SMS_53);
            //TC 6 - address field of unformatted sms are different
            response = test.envelopeSmsPp(UNFORMATTED_SMS_62);
            response = test.envelopeSmsPp(UNFORMATTED_SMS_61);
            response = test.envelopeSmsPp(UNFORMATTED_SMS_53);
            //TC 7 - some tp fields of unformatted sms are different
            response = test.envelopeSmsPp(UNFORMATTED_SMS_72);
            response = test.envelopeSmsPp(UNFORMATTED_SMS_71);
            response = test.envelopeSmsPp(UNFORMATTED_SMS_53);
            //TC 8 - unformatted sms with dcs 8bit
            response = test.envelopeSmsPp(UNFORMATTED_SMS_81);
            response = test.envelopeSmsPp(UNFORMATTED_SMS_82);
            response = test.envelopeSmsPp(UNFORMATTED_SMS_83);

            //get test result
            response = test.selectApplication(APPLET_AID_1);
            addResult(response.checkData("10"+APPLET_AID_1+
                                          "08CCCCCC CCCCCCCC CC"));

            // delete applet and package
            test.reset();
            test.terminalProfileSession("1719");
            test.deleteApplet(APPLET_AID_1);
            test.deletePackage(CAP_FILE_PATH);

            return getOverallResult();
    }
}
