//-----------------------------------------------------------------------------
//Ufw_Erp_Emcn_2 .java
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
//Package Definition
//-----------------------------------------------------------------------------
package uicc.usim.test.usatframework.ufw_erp_emcn;

//-----------------------------------------------------------------------------
//Imports
//-----------------------------------------------------------------------------
import uicc.usim.test.util.*;
import uicc.toolkit.*;
import uicc.usim.toolkit.*;

/**
* Test Area : uicc.usim.usatframework.ufw_erp_emcn
*/
public class Ufw_Erp_Emcn_2  extends TestToolkitApplet implements uicc.usim.toolkit.ToolkitConstants
{
    
    private static final byte[] BUFFER = {(byte)'A',(byte)'P',(byte)'P',(byte)'L',(byte)'E',(byte)'T'} ;
    private static final byte WAIT_FOR_USER_TO_CLEAR_MESSAGE = (byte)0x80;
    private static byte [] MenuEntry = {(byte) 'T', (byte) 'o', (byte) 'o', (byte) 'l', (byte) 'k', (byte) 'i', (byte) 't', (byte) 'T', (byte) 'e', (byte) 's', (byte) 't'};

    /**
    * Constructor of the applet
    */
    public Ufw_Erp_Emcn_2 () 
    {
    }
    
    
    /**
    * Method called by the JCRE at the installation of the applet
    */
    public static void install(byte bArray[], short bOffset, byte bLength) 
    {
        // Create a new applet instance
        Ufw_Erp_Emcn_2  thisApplet = new Ufw_Erp_Emcn_2 ();
        
        // Register the new applet instance to the JCRE            
        thisApplet.register(bArray, (short)(bOffset+1), bArray[bOffset]);
        
        // Initialise the data of the test applet
        thisApplet.init();    
        
        // Registration to EVENT_MENU_SELECTION
        thisApplet.obReg.initMenuEntry(MenuEntry, (short)0, (short)MenuEntry.length, (byte)0, false, (byte)0, (short)0);
    }
    
    
    /**
     * Method called by the USAT Framework
    */
    public void processToolkit(short event) 
    {
        // Result of each test
        boolean bRes = false;

        // Get the system instance of the ProactiveHandler class
        ProactiveHandler proHdlr = ProactiveHandlerSystem.getTheHandler() ;

        // EVENT_MENU_SELECTION :
        // --------------------------------------------
        // The applet prepares and send a Display Text Proactive command with the string "APPLET"
        try 
        {
            bRes = false;
            proHdlr.initDisplayText(WAIT_FOR_USER_TO_CLEAR_MESSAGE, (byte)0x04, BUFFER, (short)0, (short)BUFFER.length) ;
            proHdlr.send();
            bRes = true;
        }
        catch (Exception e)
        {
            bRes = false;
        }
        reportTestOutcome((byte)1, bRes);
    }
}
